unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls;

type
  TForm1 = class(TForm)
    EditTemps: TEdit;
    Label1: TLabel;
    ButtonOK: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button2: TButton;
    Image1: TImage;
    Timer1: TTimer;
    Button3: TButton;
    LabelResult: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button4: TButton;
    LabelVersion: TLabel;
    ButtonStat: TButton;
    Label7: TLabel;
    procedure ButtonOnYvaClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer1Timer2(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonStatClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label7Click(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
   a,b : integer;
   rect : TRect;

   ecart,SE,SE2,SX,SX2 : real;
   NE,NX     : integer;

implementation

uses Unit2,common, Unit3, Unit4;

{$R *.xfm}

procedure TForm1.ButtonOnYvaClick(Sender: TObject);
var
{   s : string; }
   i : cardinal;
begin
   Button2.Enabled:=false;
   a:=trunc(image1.Height/2);
   b:=trunc(image1.Width/2);
   rect.Left:=0;
   rect.Top:=0;
   rect.Right:=a*2;
   rect.Bottom:=b*2;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;

   image1.canvas.FillRect(rect);

   with image1.canvas.Brush do
   begin
     Style:=bsSolid;
     Color:=clwhite;
   end;
   image1.Canvas.Ellipse(a,b,a+5,b+5);

   with timer1 do
   begin
     i:=random(occ_rapidite);
     Interval:=i;
     {Str(i,s);
     LabelResult.Caption:=s;}
     OnTimer:=Timer1Timer;
     { on lance le timer de visibilit initiale : }
     enabled:=true;
   end;
end;

procedure TForm1.Timer1Timer2(Sender: TObject);
var
   s : string;
begin
{ Cette procdure est appele  la fin de l'occultation }
   timer1.Enabled:=false;
   occ_fin:=Gettime;
   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clBlack;
   end;
   image1.canvas.FillRect(rect);
   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clwhite;
   end;
   Image1.Canvas.Ellipse(a,b,a+5,b+5);
   With timer1 do
   begin
      OnTimer:=Timer1Timer;
      Enabled:=false;
   end;
   Button2.Enabled:=true;
   ecart:=((occ_fin-occ_debut)*86400);

   SE:=SE+Abs(ecart);
   SE2:=SE2+Ecart*Ecart;
   Inc(NE);
   Str(ecart:5:2,s);
   LabelResult.Caption:=s;
   EditTemps.Text:='';
   
{On rend possible la saisie du temps utilisateur :}
   with Label1 do begin Enabled:=True; Visible:=True; end;
   with EditTemps do begin Enabled:=True; Visible:=True; end;
   with ButtonOK do begin Enabled:=True; Visible:=True; end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   i : cardinal;
 {  s: string; }
begin
{ Cette procdure est appele au dbut de l'occultation }
   timer1.Enabled:=false;
   occ_debut:=Gettime;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;          {On efface l'toile }
   image1.canvas.FillRect(rect);
   with timer1 do
   begin
      OnTimer:=Timer1Timer2;
      I:=random(occ_rapidite);
      Interval:=i;
      {Str(I,s);
      Label6.Caption:=s; }
      Enabled:=true;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   Form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   occ_rapidite:=5000;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;

   image1.canvas.FillRect(rect);
   randomize;

   SX:=0;
   SX2:=0;
   SE:=0;
   SE2:=0;
   NX:=0;
   NE:=0;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   with Form3 do
   begin
     TextViewer1.FileName:='aide.html';
     Caption:='Aide';
     show;
   end;
end;

procedure TForm1.ButtonOKClick(Sender: TObject);
var
   code : integer;
   usertemps : real;
begin
   Val(Edittemps.Text,UserTemps,code);
   If UserTemps>0 then
   begin
      SX:=SX+Abs(UserTemps-Ecart);
      SX2:=SX2+(UserTemps-Ecart)*(UserTemps-Ecart);
      Inc(NX);
      Edittemps.Text:='';
      ButtonOk.Enabled:=false;
      with ButtonStat do begin Enabled:=True; Visible:=True; end;
   end;
end;

procedure TForm1.ButtonStatClick(Sender: TObject);
var
   SETE,SETX,s : string;
   ETE,ETX : real;
begin
   With Form4 do
   begin
      with StringGrid1 do
      begin
         Str(NE,s);
         Cells[3,1]:=s;
         Str(NX,s);
         Cells[3,2]:=s;
         Str(SE/NE:5:2,s);
         Cells[1,1]:=s;
         Str(SX/NX:5:2,s);
         Cells[1,2]:=s;

         SETE:='';
         if NE>1 then
         begin
            ETE:=sqrt((SE2-SE*SE/NE)/(NE-1));
            Str(ETE:5:2,SETE);
         end;
         cells[2,1]:=SETE;

         SETX:='';
         if NX>1 then
         begin
            ETX:=sqrt((SX2-SX*SX/NX)/(NX-1));
            Str(ETX:5:2,SETX);
         end;
         cells[2,2]:=SETX;

      end;
   end;

   Form4.Show;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
   f : textfile;
   fileexist : boolean;
begin
   if Form2.CheckBox1.Checked and (NX>1) then
   begin
     {$I-}
     assignfile(f,'.occ');
     reset(f);
     closefile(f);
     {$I+}
     FileExist:=(IOResult=0);
     AssignFile(F,'.occ');
     if fileExist then Append(f) else
     begin
        Rewrite(f);
        Writeln(f,'NbOcc. Moy.Occ. Sig.Occ. Nb.Mes. Moy.Mes Sig.Mes.');
     end;
     with Form4.StringGrid1 do
        Writeln(f,Cells[3,1],' ',cells[1,1],' ',cells[2,1],' ',
                cells[3,2],' ',cells[1,2],' ',cells[2,2]);
     CloseFile(F);
   end;
end;

procedure TForm1.Label7Click(Sender: TObject);
begin
   with Form3 do
   begin
      Caption:='Licence GPL';
      TextViewer1.FileName:='gpl_en.html';
      Show;
   end;
end;

end.
